# For developers

## Installation

```
composer require drupal/htmx
```
## Routes

When creating routes, adding `_htmx_route: 'true'` to the route
definition will cause Drupal to return a simpler response.

```yaml
your_module.custom_route:
  path: '/your_module/path'
  defaults:
    _controller: '\Drupal\your_module\Controller\CustomController::method'
    _title: 'HTMX markup'
  requirements:
    _permission: 'access content'
  options:
    _htmx_route: true
```
See [Drupal\Core\Render\Plugin\DisplayVariant\SimplePageVariant](https://git.drupalcode.org/project/drupal/-/blob/11.x/core/lib/Drupal/Core/Render/Plugin/DisplayVariant/SimplePageVariant.php)

## Libraries

This module provides the following Drupal asset libraries:

- `htmx/htmx` Just the upstream HTMX minified library.
- `htmx/drupal` The `htmx/htmx` plus JS to attach returned drupal assets and
   drupalBehaviors.
- `htmx/debug` The HTMX debug extension.  Add an `hx-ext="debug"` attribute to
   the element processing or an ancestor to see debug output in the console.
- `htmx/dialog.off-canvas` The core styles for the off-canvas dialog with some
   customization for use via htmx.
